Index: trunk/NEMO/TOP_SRC/trcrst_fdir.h90
===================================================================
--- trunk/NEMO/TOP_SRC/trcrst_fdir.h90	(revision 334)
+++ trunk/NEMO/TOP_SRC/trcrst_fdir.h90	(revision 335)
@@ -1,24 +1,22 @@
-SUBROUTINE trc_rst
-   !!===========================================================================================
-   !!
-   !!                       ROUTINE trc_rst
-   !!                     *******************
-   !!
-   !!------------------------------------------------------------------------
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
-
+   SUBROUTINE trc_rst
+      !!===========================================================================================
+      !!
+      !!                       ROUTINE trc_rst
+      !!                     *******************
+      !!
+      !!------------------------------------------------------------------------
+      !!  TOP 1.0,  LOCEAN-IPSL (2005)
+      !!----------------------------------------------------------------------
+      
       !! * Local declarations
       INTEGER :: ino0,ino1,it0,it1,idast1,jn,iarak0,iarak1
       INTEGER ::   ibloc, ilglo
       INTEGER :: inum   ! temporary logical unit
-
+      REAL(wp),DIMENSION(jpi,jpj) :: zq
       ! open restart file
       ibloc = 4096
       ilglo = ibloc*((jpiglo*jpjglo*jpbyt-1 )/ibloc+1)
       CALL ctlopn(inum,'restarti.trc','OLD','UNFORMATTED','DIRECT',   &
-                  ilglo,numout,lwp,1)
+         ilglo,numout,lwp,1)
       ! restart options
       IF(nrsttr == 0) THEN
@@ -38,21 +36,21 @@
       it0  =nit000
 
-#if defined key_trc_cen2
-      iarak0=1
-#else
-      iarak0=0
-#endif
+      IF( ln_trcadv_cen2 .OR. ln_trcadv_tvd ) THEN
+         iarak0 = 1
+      ELSE
+         iarak0=0
+      ENDIF
 
       IF(lwp) THEN
-          WRITE(numout,*) ' '
-          WRITE(numout,*) ' *** trcrst beginning of restart for'
-          WRITE(numout,*) ' passive tracer'
-          WRITE(numout,*) ' the present run :'
-          WRITE(numout,*) '   number job is  : ',no
-          WRITE(numout,*) '   with the time nit000 : ',nit000
-          IF(iarak0.eq.1) then
-              WRITE(numout,*) '   and before fields for Arakawa sheme '
-          ENDIF 
-          WRITE(numout,*) ' '
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' *** trcrst beginning of restart for'
+         WRITE(numout,*) ' passive tracer'
+         WRITE(numout,*) ' the present run :'
+         WRITE(numout,*) '   number job is  : ',no
+         WRITE(numout,*) '   with the time nit000 : ',nit000
+         IF(iarak0.eq.1) then
+            WRITE(numout,*) '   and before fields for Arakawa sheme '
+         ENDIF
+         WRITE(numout,*) ' '
       ENDIF
 
@@ -65,12 +63,12 @@
 
       IF(lwp) THEN
-          WRITE(numout,*) ' '
-          WRITE(numout,*) ' READ nutrst with '
-          WRITE(numout,*) '   number job is  : ',ino1
-          WRITE(numout,*) '   with the time it : ',it1
-          IF(iarak1.eq.1) then
-              WRITE(numout,*) '   and before fields for Arakawa sheme '
-          ENDIF 
-          WRITE(numout,*) ' '
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' READ nutrst with '
+         WRITE(numout,*) '   number job is  : ',ino1
+         WRITE(numout,*) '   with the time it : ',it1
+         IF(iarak1.eq.1) then
+            WRITE(numout,*) '   and before fields for Arakawa sheme '
+         ENDIF
+         WRITE(numout,*) ' '
       ENDIF
 
@@ -78,15 +76,15 @@
 
       IF((it0-it1) /= 1 .AND. ABS(nrsttr) == 1) THEN
-          IF(lwp) THEN
-              WRITE(numout,*) ' ===>>>> : problem with nit000 for the',   &
-                 ' passive tracer restart'
-              WRITE(numout,*) ' =======                              ',   &
-                 ' ======================'
-              WRITE(numout,*) ' we stop. verify the FILE'
-              WRITE(numout,*) ' or rerun with the value  0 for the'
-              WRITE(numout,*) ' control of time PARAMETER   nrstdt'
-              WRITE(numout,*) ' '
-          ENDIF
-          STOP 'trc_rst'
+         IF(lwp) THEN
+            WRITE(numout,*) ' ===>>>> : problem with nit000 for the',   &
+               ' passive tracer restart'
+            WRITE(numout,*) ' =======                              ',   &
+               ' ======================'
+            WRITE(numout,*) ' we stop. verify the FILE'
+            WRITE(numout,*) ' or rerun with the value  0 for the'
+            WRITE(numout,*) ' control of time PARAMETER   nrstdt'
+            WRITE(numout,*) ' '
+         ENDIF
+         STOP 'trc_rst'
       ENDIF
 
@@ -94,16 +92,16 @@
 
       IF (iarak0 /= iarak1) THEN
-          IF(lwp) THEN
-              WRITE(numout,*) ' ===>>>> : problem with the',    &
-                 ' passive tracer restart file'
-              WRITE(numout,*) ' =======                              ',   &
-                 ' ==========================='
-              WRITE(numout,*) ' we stop. verify the FILE'
-              WRITE(numout,*) ' before field required IF 1=',iarak0
-              WRITE(numout,*) ' before field present in file IF 1=',    &
-                 iarak1
-              WRITE(numout,*) ' '
-          ENDIF
-          STOP 'trc_rst'
+         IF(lwp) THEN
+            WRITE(numout,*) ' ===>>>> : problem with the',    &
+               ' passive tracer restart file'
+            WRITE(numout,*) ' =======                              ',   &
+               ' ==========================='
+            WRITE(numout,*) ' we stop. verify the FILE'
+            WRITE(numout,*) ' before field required IF 1=',iarak0
+            WRITE(numout,*) ' before field present in file IF 1=',    &
+               iarak1
+            WRITE(numout,*) ' '
+         ENDIF
+         STOP 'trc_rst'
       ENDIF
 
@@ -112,17 +110,14 @@
 
       DO jn=1,jptra
-        CALL read3(inum,trn(1,1,1,jn), jn + 1 )
+         CALL read3(inum,trn(1,1,1,jn), jn + 1 )
       END DO
 
       DO jn=1,jptra
-        CALL read3(inum,trb(1,1,1,jn), jptra + jn + 1 )
+         CALL read3(inum,trb(1,1,1,jn), jptra + jn + 1 )
       END DO
 
-#if defined key_trc_hamocc3
-      CALL read2(inum,sedcal(:,:),jpk,2*jptra+2)
-      CALL read2(inum,sedsil(:,:),jpk,2*jptra+3)
-      CALL read2(inum,sedpoc(:,:),jpk,2*jptra+4)
-#elif defined key_trc_npzd || defined key_trc_lobster1
-      CALL read2(inum,sedpoc(:,:),jpk,2*jptra+2)
+#if defined key_trc_lobster1
+      CALL read2(inum,sedpocb(:,:),jpk,2*jptra+2)
+      CALL read2(inum,sedpocn(:,:),jpk,2*jptra+3)
 #elif defined key_trc_pisces
 
@@ -133,26 +128,34 @@
       CALL read2(inum,sedsil(:,:),jpk,2*jptra+4)
       CALL read2(inum,sedpoc(:,:),jpk,2*jptra+5)
+
+#elif defined key_cfc
+      DO jn=1,jptra
+         CALL read2(inum,zq(:,:),jpk,2*jptra+2)
+         qint(:,:,jn) = zq(:,:)
+         CALL read2(inum,zq(:,:),jpk,2*jptra+3)
+         qtr(:,:,jn)=zq(:,:)
+      ENDDO
 #endif
 
-#if defined key_trc_hamocc3 || defined key_trc_pisces
-
-
-    !!  Initialization of chemical variables of the carbon cycle
-    !!  --------------------------------------------------------
-
-        DO jk = 1,jpk
-          DO jj = 1,jpj
+#if  defined key_trc_pisces
+
+
+      !!  Initialization of chemical variables of the carbon cycle
+      !!  --------------------------------------------------------
+
+      DO jk = 1,jpk
+         DO jj = 1,jpj
             DO ji = 1,jpi
-              caralk = trn(ji,jj,jk,jptal)-       &
-              &        borat(ji,jj,jk)/(1.+1.E-8/(rtrn+akb3(ji,jj,jk)))
-              co3(ji,jj,jk)=(caralk-trn(ji,jj,jk,jpdic))*tmask(ji,jj,jk)   &
-              &        +(1.-tmask(ji,jj,jk))*.5e-3
-              bicarb = (2.*trn(ji,jj,jk,jpdic)-caralk)
-              hi(ji,jj,jk) = (ak23(ji,jj,jk)*bicarb/co3(ji,jj,jk))     &
-              &  *tmask(ji,jj,jk)+(1.-tmask(ji,jj,jk))*1.e-9
-              h2co3(ji,jj) = 1.e-5
+               caralk = trn(ji,jj,jk,jptal)-       &
+                  &        borat(ji,jj,jk)/(1.+1.E-8/(rtrn+akb3(ji,jj,jk)))
+               co3(ji,jj,jk)=(caralk-trn(ji,jj,jk,jpdic))*tmask(ji,jj,jk)   &
+                  &        +(1.-tmask(ji,jj,jk))*.5e-3
+               bicarb = (2.*trn(ji,jj,jk,jpdic)-caralk)
+               hi(ji,jj,jk) = (ak23(ji,jj,jk)*bicarb/co3(ji,jj,jk))     &
+                  &  *tmask(ji,jj,jk)+(1.-tmask(ji,jj,jk))*1.e-9
+               h2co3(ji,jj) = 1.e-5
             ENDDO
-          ENDDO
-        ENDDO
+         ENDDO
+      ENDDO
 #endif
 
@@ -161,12 +164,12 @@
    END SUBROUTINE trc_rst
 
-SUBROUTINE trc_wri(kt)
-   !! ==================================================================================
-   !!
-   !!                       ROUTINE trc_wri
-   !!                     ******************
-   !!
-   !!========================================================================================!
-     !! * Arguments
+   SUBROUTINE trc_wri(kt)
+      !! ==================================================================================
+      !!
+      !!                       ROUTINE trc_wri
+      !!                     ******************
+      !!
+      !!========================================================================================!
+      !! * Arguments
       !! -----------
       INTEGER, INTENT( in ) :: kt
@@ -175,4 +178,5 @@
       INTEGER :: jn
       INTEGER :: ino0,it0,iarak0
+      REAL(wp),DIMENSION(jpi,jpj) :: zq
 
       IF( kt == nit000 ) THEN
@@ -190,20 +194,19 @@
          ! ------------------
 
-          IF(lwp) THEN
-              WRITE(numout,*) ' '
-              WRITE(numout,*)       &
-              &  ' trcwri: restart OUTPUT done in nutwrs = ',nutwrs    &
-              &  ,' at it= ',kt,' date= ',ndastp
-              WRITE(numout,*) ' -------'
-          ENDIF
-
-          ino0 =no
-          it0  =kt
-
-#if defined key_trc_cen2
-          iarak0=1
-#else
-          iarak0=0
-#endif
+         IF(lwp) THEN
+            WRITE(numout,*) ' '
+            WRITE(numout,*)       &
+               &  ' trcwri: restart OUTPUT done in nutwrs = ',nutwrs    &
+               &  ,' at it= ',kt,' date= ',ndastp
+            WRITE(numout,*) ' -------'
+         ENDIF
+
+         ino0 =no
+         it0  =kt
+         IF( ln_trcadv_cen2 .OR. ln_trcadv_tvd ) THEN
+            iarak0 = 1
+         ELSE
+            iarak0=0
+         ENDIF
 
          ! 1. Write in nutwrs
@@ -213,24 +216,28 @@
             ino0, it0, iarak0
 
-          DO jn=1,jptra
+         DO jn=1,jptra
             CALL write3(nutwrs,trn(1,1,1,jn), jn + 1 )
-          END DO
-
-          DO jn=1,jptra
+         END DO
+
+         DO jn=1,jptra
             CALL write3(nutwrs,trb(1,1,1,jn), jptra + jn + 1 )
-          END DO
-
-#if defined key_trc_hamocc3
-             CALL write2(nutwrs,sedcal,jpk,2*jptra+2)
-             CALL write2(nutwrs,sedsil,jpk,2*jptra+3)
-             CALL write2(nutwrs,sedpoc,jpk,2*jptra+4)
-#elif defined key_trc_npzd || defined key_trc_lobster1
-             CALL write2(nutwrs,sedpoc,jpk,2*jptra+2)
+         END DO
+
+#if defined key_trc_lobster1
+         CALL write2(nutwrs,sedpocb,jpk,2*jptra+2)
+         CALL write2(nutwrs,sedpocn,jpk,2*jptra+3)
 #elif defined key_trc_pisces
-             CALL write2(nutwrs,xksi,jpk,2*jptra+2)
-
-             CALL write2(nutwrs,sedcal,jpk,2*jptra+3)
-             CALL write2(nutwrs,sedsil,jpk,2*jptra+4)
-             CALL write2(nutwrs,sedpoc,jpk,2*jptra+5)
+         CALL write2(nutwrs,xksi,jpk,2*jptra+2)
+
+         CALL write2(nutwrs,sedcal,jpk,2*jptra+3)
+         CALL write2(nutwrs,sedsil,jpk,2*jptra+4)
+         CALL write2(nutwrs,sedpoc,jpk,2*jptra+5)
+#elif defined key_cfc
+         DO jn=1,jptra
+            zq(:,:)=qint(:,:,jn)
+            CALL write2(nutwrs,zq,jpk,2*jptra+2)
+            zq(:,:)=qtr(:,:,jn)
+            CALL write2(nutwrs,zq,jpk,2*jptra+3)
+         ENDDO
 #endif
       ENDIF
Index: trunk/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcsms.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/trcsms.F90	(revision 335)
@@ -8,160 +8,132 @@
    !!===========================================================================================
    !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
    !!----------------------------------------------------------------------
+#if defined key_passivetrc   
+   !! * Modules used
+   !! ==============
+   USE oce_trc
+   USE trc
+   USE trcfreons
 
-      !! * Modules used
-      !! ==============
-      USE oce_trc
-      USE trc
-
-      IMPLICIT NONE
-      PRIVATE
+   IMPLICIT NONE
+   PRIVATE
 
    !! * Accessibility
    PUBLIC trc_sms
 
-#if defined key_passivetrc
-
 CONTAINS
 
-SUBROUTINE trc_sms( kt )
-   !!===========================================================================================
-   !!
-   !!                       ROUTINE trcsms
-   !!                     *****************
-   !!
-   !!  PURPOSE :
-   !!  ---------
-   !!          time loop of opa for passive tracer
-   !!
-   !!   METHOD :
-   !!   -------
-   !!      compute the well/spring evolution
-   !!
-   !!   INPUT :
-   !!   -----
-   !!      argument
-   !!              ktask           : task identificator
-   !!              kt              : time step
-   !!      COMMON
-   !!            all the COMMON defined in opa
-   !!
-   !!
-   !!   OUTPUT :			: no
-   !!   ------
-   !!
-   !!   WORKSPACE :
-   !!   ---------
-   !!
-   !!   EXTERNAL :
-   !!   --------
-   !!      trcbio, trcsed, trcopt for NPZD or LOBSTER1 models
-   !!
-   !!      h3cprg for HAMOC3 and P3ZD models
-   !!
-   !!
-   !!   History:
-   !!   --------
-   !!      original  : 96-11
-   !!      additions : 99-07 (M. Levy)
-   !!                  04-00 (O. Aumont, M.A. Foujols) HAMOCC3 and P3ZD
-   !!                  12-00 (O. Aumont, E. Kestenare) add trcexp for instantaneous export 
-   !!   05-03 (O. Aumont and A. El Moussaoui) F90
-   !! -------------------------------------------------------------------------------------
+   SUBROUTINE trc_sms( kt )
+      !!===========================================================================================
+      !!
+      !!                       ROUTINE trcsms
+      !!                     *****************
+      !!
+      !!  PURPOSE :
+      !!  ---------
+      !!          time loop of opa for passive tracer
+      !!
+      !!   METHOD :
+      !!   -------
+      !!      compute the well/spring evolution
+      !!
+      !!   INPUT :
+      !!   -----
+      !!      argument
+      !!              ktask           : task identificator
+      !!              kt              : time step
+      !!      COMMON
+      !!            all the COMMON defined in opa
+      !!
+      !!
+      !!   OUTPUT :			: no
+      !!   ------
+      !!
+      !!   WORKSPACE :
+      !!   ---------
+      !!
+      !!   EXTERNAL :
+      !!   --------
+      !!      trcbio, trcsed, trcopt for NPZD or LOBSTER1 models
+      !!
+      !!      h3cprg for HAMOC3 and P3ZD models
+      !!
+      !!
+      !!   History:
+      !!   --------
+      !!      original  : 96-11
+      !!      additions : 99-07 (M. Levy)
+      !!                  04-00 (O. Aumont, M.A. Foujols) HAMOCC3 and P3ZD
+      !!                  12-00 (O. Aumont, E. Kestenare) add trcexp for instantaneous export 
+      !!   05-03 (O. Aumont and A. El Moussaoui) F90
+      !! -------------------------------------------------------------------------------------
 
-   !! * Arguments
-   !! -----------
+      !! * Arguments
+      !! -----------
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
 
-   !! this ROUTINE is called only every ndttrc time step
-   !! --------------------------------------------------
+      !! this ROUTINE is called only every ndttrc time step
+      !! --------------------------------------------------
 
       IF ( MOD(kt,ndttrc) /= 0) RETURN
 
-   !! this first routines are parallelized on vertical slab
-   !! ------------------------------------------------------
+      !! this first routines are parallelized on vertical slab
+      !! ------------------------------------------------------
 
-#if defined key_trc_npzd || defined key_trc_lobster1
+#if defined key_trc_lobster1
 
-   !! tracers: optical model
-   !! ----------------------
+      !! tracers: optical model
+      !! ----------------------
 
-       CALL trcopt( kt)
+      CALL trcopt( kt)
 
-   !! tracers: biological model
-   !! -------------------------
+      !! tracers: biological model
+      !! -------------------------
 
-       CALL trcbio( kt)
+      CALL trcbio( kt)
 
-   !! tracers: sedimentation model
-   !! ----------------------------
+      !! tracers: sedimentation model
+      !! ----------------------------
 
-       CALL trcsed(kt)
-       CALL trcexp
+      CALL trcsed(kt)
+      CALL trcexp(kt)
 
-#elif defined key_trc_hamocc3
 
-   !! h3cprg: main PROGRAM for HAMOCC3 or P3ZD models
-   !! -----------------------------------------------
-       CALL h3cprg(kt)
 
 #elif defined key_trc_pisces
 
-   !! p4zprg: main PROGRAM for PISCES 
-   !! -------------------------------
-       CALL p4zprg(kt)
-#else
+      !! p4zprg: main PROGRAM for PISCES 
+      !! -------------------------------
+      CALL p4zprg(kt)
 
-    !! SMS to DO
+      !! SMS to DO
 
-#if defined key_cfc
+#elif defined key_cfc
 
-   !! CFC's code taken from K. Rodgers
+      !! CFC's code taken from K. Rodgers
 
-   !! This part is still experimental
-   !! -------------------------------
+      !! This part is still experimental
+      !! -------------------------------
 
-       CALL trcfreons(kt)
-
-#elif defined key_gosac
-
-   !! C14 tracer modeled according to the OCMIP protocol
-   !! This part has not been really tested in this configuration
-
-   !! Compute the alkalinity
-
-          CALL alkal(kt)
-
-   !! Compute the radioactive decay
-
-          CALL decay
-
-   !! Tracers: surface flux
-
-          CALL dicgasflux(kt)
+      CALL trc_freons(kt)
 
 #endif
 
-#endif
 
-#if defined key_trc_age
 
-   !! Age Tracer 
-   
-          CALL trcage(kt)
-#endif
-
-END SUBROUTINE trc_sms
+   END SUBROUTINE trc_sms
 
 #else
+   !!======================================================================
+   !!  Empty module : No passive tracer
+   !!======================================================================
+CONTAINS
 
-SUBROUTINE trc_sms( kt )
+   SUBROUTINE trc_sms( kt )
 
-! no passive tracers
+      ! no passive tracers
       INTEGER, INTENT( in ) ::   kt
       WRITE(*,*) 'trc_sms: You should not have seen this print! error?', kt
-END SUBROUTINE trc_sms
+   END SUBROUTINE trc_sms
 
 #endif 
